#if ! defined(__CROSS_H)
#define __CROSS_H

#include "owntypes.h"
#include "cb.h"
#include "solution.h"

/*---------------------- Supported methods ---------------------------*/
/*    Method 0:  Copy solution                                        */
/*    Method 1:  Random crossover                                     */
/*    Method 2:  Centroid distance                                    */
/*    Method 3:  Largest partitions - under construction !!!          */
/*    Method 4:  Pairwise crossover - under construction !!!          */
/*    Method 5:  Adaptive pairwise                                    */
/*    Method 6:  PNN original - not supported anymore !!!             */
/*    Method 7:  PNN fast                                             */
/*    Method 8:  Adoption swap                                        */
/*--------------------------------------------------------------------*/

void CrossSolutions(TRAININGSET* TS,
                    SOLUTION*    S1,
                    SOLUTION*    S2,
                    SOLUTION*    S3,
                    int          Method);

void Mutate(TRAININGSET* TS,
            SOLUTION*    S,
            int          NumberOfMutations);

/*--------------------------------------------------------------------*/

#endif /* __CROSS_H */
